//------------------------------------------------------------------------------------//
// CallLogs meldet sich bei Fritz!box an, um mitzubekommen                            //
// wenn ein Telefonanruf ankommt oder ein Telefonanruf getätigt wird.                 //
// Nach dem Start wird ein Trayicon eingetragen.                                      //
// Beenden des Programms mit Rechtsklick am Trayicon.                                 //
//                                                                                    //
// Benötigte Komponente: synapse   synapse.ararat.cz/doku.php/download                //
//                       DataPort  github.com/serbod/dataport                         //
//                                                                                    //
// Die Funktion muss bei der Fritz!box freigeschalten werden.                         //
// Der Port 1012 wird mit dem Code #96*5* an einem angeschlossenen Telefon geöffnet   //
// und wenn nicht mehr benötigt mit #96*4* wieder geschlossen.                        //
//                                                                                    //
// Quelle meiner Erkenntnis: www.fr-an.de/programming/callmonitor/index.htm
                                    //  Leider nicht mehr im Netz //
// CallLogs läuft auch unter Linux. Viel Spass :-)                                    //
//                                                                                    //
// Autor: bibsi (ein interessierter Laie)                                             //
//        übernehme keinerlei Haftung / assume no liability                           //
//------------------------------------------------------------------------------------//

unit main_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Dialogs, StdCtrls, Menus,
  ExtCtrls, DividerBevel, DataPortIP, LCLType, LCLIntf;

type

  { TFormCallLogs }

  TFormCallLogs = class(TForm)
    DataPortTCP1: TDataPortTCP;
    DividerBevel1: TDividerBevel;
    EditRemoteHost: TEdit;
    EditRemotePort: TEdit;
    ListBox1: TListBox;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PopupMenu1: TPopupMenu;
    TrayIcon1: TTrayIcon;
    procedure DataPortTCP1Close(Sender: TObject);
    procedure DataPortTCP1DataAppear(Sender: TObject);
    procedure DataPortTCP1Error(Sender: TObject; const AMsg: ansistring);
    procedure DataPortTCP1Open(Sender: TObject);
    procedure DividerBevel1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure TrayIcon1Click(Sender: TObject);
  private

  public

  end;

var
  FormCallLogs: TFormCallLogs;
  boBeenden: boolean = False;

implementation

{$R *.lfm}

{ TFormCallLogs }

procedure TFormCallLogs.FormCreate(Sender: TObject);
begin
  { ~ Kein Eintag in der Taskleiste -------------------------------------------------------------------}
  FormCallLogs.ShowInTaskBar := stNever;

  { ~ Die Größe der Form begränzen --------------------------------------------------------------------}
  Constraints.MinWidth := 500;
  Constraints.MinHeight := 500;
  Constraints.MaxWidth := 500;
  FormCallLogs.WindowState := wsNormal; //wsMinimized;

  Caption := 'Call-Logs';
  DividerBevel1.Caption := 'Nicht verbunden';
  DataPortTCP1.RemoteHost := 'fritz.box';
  DataPortTCP1.RemotePort := '1012';
  DataPortTCP1.Open();
  { ~ gespeicherte Anrufliste laden -------------------------------------------------------------------}
  ListBox1.Items.LoadFromFile('./calllist.txt');
end;

procedure TFormCallLogs.FormDestroy(Sender: TObject);
begin
  { ~ gesammelte Anrufe in Textdatei speicher ---------------------------------------------------------}
  ListBox1.Items.SaveToFile('./calllist.txt');
end;

procedure TFormCallLogs.MenuItem1Click(Sender: TObject);
begin
  { ~ Anrufliste löschen ------------------------------------------------------------------------------}
  ListBox1.Items.Clear;
end;

procedure TFormCallLogs.MenuItem2Click(Sender: TObject);
begin
  { ~ Programm über PopUpMenue beenden ----------------------------------------------------------------}
  boBeenden := True;
  Close;
end;

procedure TFormCallLogs.TrayIcon1Click(Sender: TObject);
begin
  { ~ Fenster anzeigen oder verbergen -----------------------------------------------------------------}
  // if FormCallLogs.WindowState in [wsMinimized] then  begin
  if FormCallLogs.WindowState = wsMinimized then
  begin
    FormCallLogs.WindowState := wsNormal;
    Application.ShowMainForm := True;
    FormCallLogs.Show;
  end
  else
    FormCallLogs.WindowState := wsMinimized;
end;

procedure TFormCallLogs.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  DataPortTCP1.Close();
  CloseAction := caFree;
end;

procedure TFormCallLogs.DividerBevel1DblClick(Sender: TObject);
begin
  { ~ Die Portverbindung trennen und/oder
      Werte der Eingabefelder übernehem und neu verbinden ---------------------------------------------}
  if DataPortTCP1.Active then
    DataPortTCP1.Active := False
  else
  begin
    DataPortTCP1.RemoteHost := EditRemoteHost.Text;
    DataPortTCP1.RemotePort := EditRemotePort.Text;
    DataPortTCP1.Active := True;
  end;
end;

procedure TFormCallLogs.DataPortTCP1Open(Sender: TObject);
begin
  { ~ Wenn Verbindung aufgebaut ist -------------------------------------------------------------------}
  DividerBevel1.Caption := 'Mit Router verbunden';
  EditRemoteHost.Enabled:=false;EditRemotePort.Enabled:=false;
end;

procedure TFormCallLogs.DataPortTCP1Error(Sender: TObject; const AMsg: ansistring);
begin
  { ~ Wenn Portverbindung einen Fehler meldet
      in der Liste eintragen, danach Portverbindung trennen -------------------------------------------}
  ListBox1.Items.Add('Error: ' + AMsg);
  DataPortTCP1.Close();
end;

procedure TFormCallLogs.DataPortTCP1Close(Sender: TObject);
begin
  { ~ Die Trennung der Portverbindung
      anzeigen ----------------------------------------------------------------------------------------}
  DividerBevel1.Caption := 'Nicht verbunden';
  EditRemoteHost.Enabled:=true;EditRemotePort.Enabled:=true;
end;

procedure TFormCallLogs.DataPortTCP1DataAppear(Sender: TObject);
var
  slAnrufDaten: TStringList;
  Zeile: string;
  i: integer;
begin
  { ~ Stringliste anlegen -----------------------------------------------------------------------------}
  slAnrufDaten := TStringList.Create;
  Zeile := '';
  { ~ Meldung durch StringList.Delimitertext aufteilen (DelimiterZeichen) ';' angeben -----------------}
  slAnrufDaten.Delimiter := ';';
  { ~ Auch Leerzeichen werden als Trenner interpretiert (Datum und Uhrzeit) ---------------------------}
  slAnrufDaten.DelimitedText := DataPortTCP1.Pull();
  for i := 0 to slAnrufDaten.Count - 1 do
    Zeile := Zeile + ' ' + slAnrufDaten.Strings[i];
  ListBox1.Items.Add(Zeile);

  { ~ Angelegte Stringliste freigeben -----------------------------------------------------------------}
  slAnrufDaten.Free;

  if FormCallLogs.WindowState = wsMinimized then
  begin
    FormCallLogs.WindowState := wsNormal;
    Application.ShowMainForm := True;
    FormCallLogs.Show;
  end;

end;

procedure TFormCallLogs.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  { ~ Nur Programm beenden wenn über PopUpMenue--------------------------------------------------------}
  if not boBeenden then
    FormCallLogs.WindowState := wsMinimized;
  CanClose := boBeenden;
end;

end.
